api/urls.py
urlpatterns = [

]

bases/urls.py
from django import template
from bases.views import Home, HomeSinPrivilegios
from django.urls import path
from django.contrib.auth import views as auth_views

urlpatterns = [
    path('', Home.as_view(), name='home'),
    path('login/', auth_views.LoginView.as_view(template_name='bases/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='bases/login.html'), name='logout'),
    path('sin_privilegios/', HomeSinPrivilegios.as_view(), name="sin_privilegios"),
]

syscofa/urls.py
from argparse import Namespace
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include(('bases.urls', 'bases'), namespace='bases')),
    path('inv/', include(('inv.urls', 'inv'), namespace='inv')),
    path('cmp/', include(('cmp.urls', 'cmp'), namespace='cmp')),
    path('fac/', include(('fac.urls', 'fac'), namespace='fac')),
    path('api/', include(('api.urls', 'api'), namespace='api')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls')),    
]

bases/models.py
from tkinter import CASCADE
from django.db import models
from django.contrib.auth.models import User
from django_userforeignkey.models.fields import UserForeignKey

# Create your models here.
class ClaseModelo(models.Model):
    estado = models.BooleanField(default=True)
    fc = models.DateTimeField(auto_now_add=True) #fecha de creación
    fm = models.DateTimeField(auto_now=True)     #fecha de modificación
    uc = models.ForeignKey(User, on_delete=models.CASCADE) #usuario de creación
    um = models.IntegerField(blank=True, null=True) #usuario de modificación

    class Meta:
        # se ignora este modelo al momento de hacer las migraciones
        abstract=True

class ClaseModelo2(models.Model):
    estado = models.BooleanField(default=True)
    fc = models.DateTimeField(auto_now_add=True) #fecha de creación
    fm = models.DateTimeField(auto_now=True)     #fecha de modificación
    # uc = models.ForeignKey(User, on_delete=models.CASCADE) #usuario de creación
    # um = models.IntegerField(blank=True, null=True) #usuario de modificación
    uc = UserForeignKey(auto_user_add=True, related_name='+')
    um = UserForeignKey(auto_user=True, related_name='+')

    class Meta:
        # se ignora este modelo al momento de hacer las migraciones
        abstract=True

bases/views.py
from logging import raiseExceptions
from django.http import HttpResponseRedirect
from django.urls import reverse_lazy
from re import template
from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin

# Create your views here.
from django.views import generic
from django.views.generic.base import TemplateView

class Sin_Privilegios(LoginRequiredMixin, PermissionRequiredMixin):
    login_url = 'bases:login'
    raiseExceptions = False
    redirect_field_name = "redirect_to"

    def handle_no_permission(self):
        from django.contrib.auth.models import AnonymousUser

        # si el usuario es válido, se muestra la vista sin privilegios
        if not self.request.user == AnonymousUser():
            self.login_url = "bases:sin_privilegios"

        return HttpResponseRedirect(reverse_lazy(self.login_url))

class Home(LoginRequiredMixin, TemplateView):    
    template_name = 'bases/home.html'
    login_url = 'bases:login' # sino esta logeado se redireccona al admin

class HomeSinPrivilegios(LoginRequiredMixin, generic.TemplateView):
    template_name = "bases/sin_privilegios.html"

class VistaBaseCreate(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
    context_object_name = "obj"
    success_message = "Registro Agregado Satisfactoriamente"

    def form_valid(self, form):
        form.instance.uc = self.request.user 
        return super().form_valid(form)

class VistaBaseEdit(SuccessMessageMixin, Sin_Privilegios, generic.UpdateView):
    context_object_name = "obj"
    success_message = "Registro Actualizado Satisfactoriamente"

    def form_valid(self, form):
        form.instance.um = self.request.user.id 
        return super().form_valid(form)

bases/templates/bases/home.html
{% extends 'base/base.html' %}

bases/templates/bases/login.html
{% extends 'base/base.html' %}

{% block side_bar %} {% endblock side_bar %}
{% block top_bar %} {% endblock top_bar %}
{% block page_content %} {% endblock page_content %}
{% block footer %} {% endblock footer %}
{% block login %} 
<div class="container">

    <!-- Outer Row -->
    <div class="row justify-content-center">

        <div class="col-xl-10 col-lg-12 col-md-9">

            <div class="card o-hidden border-0 shadow-lg my-5">
                <div class="card-body p-0">
                    <!-- Nested Row within Card Body -->
                    <div class="row">
                        <div class="col-lg-6 d-none d-lg-block bg-login-image"></div>
                        <div class="col-lg-6">
                            <div class="p-5">
                                <div class="text-center">
                                    <h1 class="h4 text-gray-900 mb-4">Welcome Back!</h1>
                                    <small class="text-danger">
                                        
                                        {% if form.errors %} <!-- si el formulario tiene errores -->                                            
                                            {% for field in form %}                                                
                                                {% if field.errors %}                                                    
                                                    {% for error in field.errors %}
                                                        {{ error|escape }}
                                                    {% endfor %}                                                                                                        
                                                {% endif %}                                                    
                                            {% endfor %}                                                
                                        {% endif %}

                                        
                                        {% if form.non_field_errors %}                                            
                                            {% for error in form.non_field_errors %}
                                                {{ error|escape }}                                                
                                            {% endfor %}                                                
                                        {% endif %}                                            
                                            
                                    </small>
                                </div>
                                <form class="user" method="POST">
                                    {% csrf_token %}
                                    <div class="form-group">
                                        <input type="text" class="form-control form-control-user"
                                            id="id_username" name="username" aria-describedby="emailHelp"
                                            placeholder="Ingresa el nombre de usuario...">
                                    </div>
                                    
                                    <div class="form-group">
                                        <input type="password" class="form-control form-control-user"
                                            id="id_password" name="password" placeholder="Ingresa el password...">
                                    </div>
                                    <!-- {{ form.as_p }} -->
                                    <button type="submit" class="btn btn-primary btn-user btn-block">Acceder</button>
                                   
                                </form>                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>

    </div>
</div>
{% endblock login %}

{% block js_page %} 
<script>
    {% if form.errors %} 
        {% for field in form %}
            {% if field.errors %}
                {% for error in field.errors %}
                    mensaje('{{ error | escape }}', 'red')
                {% endfor %}
            {% endif %}
        {% endfor %}
    {% endif %}


    {% if form.non_field_errors %}
        {% for error in form.non_field_errors %}
            mensaje('{{ error | escape }}', 'red')
        {% endfor %}
    {% endif %}       
</script>
{% endblock js_page %}

bases/templates/bases/sin_privilegios.html
{% extends 'base/base.html' %}

{% block page_content %}
    <div class="col-xl-6 col-md-6 mb-6">
        <div class="card border-left-danger shadow h-100 py-2">
            <div class="card-body">
                <div class="row no-gutters align-items-center">
                    <div class="col mr-2">
                        <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                            USUARIO: <mark> {{ user.username }} {{ user.get_full_name }}</mark>
                        </div>
                        <div class="dropdown-divider"></div>

                        <div class="row">
                            <mark>No tiene suficientes privilegios</mark> para cargar la opción solicitada.
                            <br>
                            <small>Para poder acceder, debe logearse con un usuario con privilegios necesarios.</small>
                        </div>

                        <div class="dropdown-divider"></div>

                        <div class="row">
                            <div class="col">
                                <a href="{% url 'bases:home' %}" class="btn btn-success"><span class="fa fa-home">Ir a Inicio</span></a>
                                <a href="{% url 'bases:login' %}" class="btn btn-success"><span class="fa fa-user">Ingresar con otro usuario</span></a>
                            </div>
                        </div>
                    </div>

                    <div class="col-auto">
                        <i class="far fa-calendar-plus fa-2x text-gray-300"></i>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock page_content %}
    